      $SET SQL(dbman=ODBC)
      $SET SOURCEFORMAT(VARIABLE)
      ****************************************************************
      * Copyright (C) Micro Focus 1988-2022. All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      * 
      ****************************************************************
       WORKING-STORAGE SECTION.
           EXEC SQL INCLUDE SQLCA END-EXEC.
           EXEC SQL BEGIN DECLARE SECTION END-EXEC.
       01 HV-EMPNO                PIC S9(9) COMP-5.
       01 HV-EMPDEPT.
          03 HV-ENAME             PIC X(10).
          03 HV-JOB               PIC X(12).
          03 HV-SAL               PIC S9(7)V9(2) COMP-3.
          03 HV-DNAME             PIC X(14).
           EXEC SQL END DECLARE SECTION END-EXEC.
       01 MFSQLMESSAGETEXT        PIC X(250).
       01 DUMMY-ARR               OCCURS 5 TIMES PIC X(10).
       01 DUMMY-IDX               PIC 9(1) VALUE 6.
       LINKAGE SECTION.
       01 OP-CODE                 PIC X(1).
       01 MOD-VAL                 PIC 9(5) COMP-3.
       01 LNK-EMPNO               PIC S9(9) COMP-5.
       01 LNK-EMPDEPT.
          03 LNK-ENAME            PIC X(10).
          03 LNK-JOB              PIC X(12).
          03 LNK-SAL              PIC 9(7)V9(2) COMP-3.
          03 LNK-DNAME            PIC X(14).
      *
       PROCEDURE DIVISION USING OP-CODE MOD-VAL LNK-EMPNO LNK-EMPDEPT.
       MAIN-PROC.
           EXEC SQL
             WHENEVER SQLERROR GO TO DB-Error
           END-EXEC.

           MOVE LNK-EMPNO TO HV-EMPNO.

           EXEC SQL
               SELECT SAL INTO :HV-SAL
                 FROM EMP
                 WHERE EMPNO = :HV-EMPNO
           END-EXEC.

           EVALUATE OP-CODE
             WHEN "D"
               COMPUTE HV-SAL = HV-SAL - MOD-VAL
             WHEN "I"
               COMPUTE HV-SAL = HV-SAL + MOD-VAL
           END-EVALUATE.

           EXEC SQL
               UPDATE EMP
                 SET SAL = :HV-SAL
                 WHERE EMPNO = :HV-EMPNO
           END-EXEC.

           MOVE ALL'A' TO DUMMY-ARR(DUMMY-IDX).

           EXEC SQL
               SELECT ENAME, JOB, SAL, DNAME
                 INTO :HV-ENAME, :HV-JOB, :HV-SAL, :HV-DNAME
                 FROM EMP INNER JOIN DEPT
                 ON EMP.DEPTNO = DEPT.DEPTNO
                 WHERE EMPNO = :HV-EMPNO
           END-EXEC.
           
           MOVE HV-EMPDEPT TO LNK-EMPDEPT.

           GOBACK.

       DB-Error Section.

           DISPLAY "SQL Error = " SQLSTATE " " SQLCODE UPON CONSOLE.
           DISPLAY MFSQLMESSAGETEXT UPON CONSOLE.
           GOBACK.
